
// BitBangI2CDlg.cpp : t@C
//

#include "stdafx.h"
#include "BitBangI2C.h"
#include "BitBangI2CDlg.h"
#include "FtException.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define	NELEMS(arg)	(sizeof(arg) / sizeof((arg)[0]))

enum TIMER_ID
{
	TIMER_ID_UPDATE,
};

enum PIN_BIT
{
	BIT_SCL_O	= 0,				// D0: SCL Output
	BIT_SDA_O	= 4,				// D4: SDA Output
	BIT_SDA_I	= 1,				// D1: SDA Input
};

typedef struct tagREG_INFO
{
	INA226_REG	reg;
	const char*	name;
}REG_INFO;

const static REG_INFO	st_aRegs[] = {
	{	INA226_REG_CONGIGURATION_REG,	"Configuration Register"	},
	{	INA226_REG_SHUNT_VOLTAGE,		"Shunt Voltage"				},
	{	INA226_REG_BUS_VOLTAGE,			"Bus Voltage"				},
	{	INA226_REG_POWER,				"Power"						},
	{	INA226_REG_CURRENT,				"Current"					},
	{	INA226_REG_CALIBRATION,			"Calibration"				},
	{	INA226_REG_MASK_ENABLE,			"Mask/Enable"				},
	{	INA226_REG_ALERT_LIMIT,			"Alert Limit"				},
	{	INA226_REG_DIE_ID,				"Die ID"					},
};

// AvP[Ṽo[WɎg CAboutDlg _CAO
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBitBangI2CDlg _CAO
CBitBangI2CDlg::CBitBangI2CDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBitBangI2CDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBitBangI2CDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_REG,			m_lcReg);
	DDX_Control(pDX, IDC_STATIC_BUS,		m_stBus);
	DDX_Control(pDX, IDC_STATIC_CURRENT,	m_stCurr);
	DDX_Control(pDX, IDC_STATIC_POWER,		m_stPow);
}

BEGIN_MESSAGE_MAP(CBitBangI2CDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CBitBangI2CDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CBitBangI2CDlg::OnBnClickedCancel)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



WORD CBitBangI2CDlg::GetRegister(INA226_REG reg)
{
	WORD	res;

	m_i2c.BeginTransmission(INA226_ADDR, FALSE);
	m_i2c.SendByte(reg, TRUE);
	m_i2c.EndTransmission();
	m_i2c.Commit();

	m_i2c.BeginTransmission(INA226_ADDR, TRUE);
	m_i2c.ReadBytes(2);
	m_i2c.EndTransmission();


	// I2CoXM
	CByteArray	data;
	m_i2c.Commit(&data);

	if(data.GetSize() >= 2)
		res	= (data[0] * 256) + data[1];
	else
		res = 0x0000;

	return	res;
}

// CBitBangI2CDlg bZ[W nh
BOOL CBitBangI2CDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	m_font.CreatePointFont(48*10, "Century");
	m_stBus.SetFont(&m_font);
	m_stCurr.SetFont(&m_font);
	m_stPow.SetFont(&m_font);

	//m_fontUnit.CreatePointFont(160*10, "MS SVbN");
	//m_stUnit.SetFont(&m_fontUnit);

	try
	{
		// foCX̃I[v
		m_i2c.Open(0, 9600, BIT_SCL_O, BIT_SDA_O, BIT_SDA_I);

	//	TRACE1("Die ID : %04X\n", GetRegistor(INA226_REG_CONGIGURATION_REG));
		m_lcReg.InsertColumn(0, "Reg", LVCFMT_LEFT, 32);
		m_lcReg.InsertColumn(1, "Name", LVCFMT_LEFT, 140);
		m_lcReg.InsertColumn(2, "Value", LVCFMT_LEFT, 50);

		int i;
		for(i = 0; i < NELEMS(st_aRegs); i++)
		{
			const REG_INFO* pInfo = &st_aRegs[i];
			CString	str;
		
			str.Format("%02X", pInfo->reg);
			m_lcReg.InsertItem(i, str);

			m_lcReg.SetItemText(i, 1, pInfo->name);
		}

		WORD	val;

		val = 0x4127 | (0x111 << 9);
		m_i2c.BeginTransmission(INA226_ADDR, FALSE);
		m_i2c.SendByte(INA226_REG_CONGIGURATION_REG, FALSE);
		m_i2c.SendByte((val >> 8) & 0xFF, FALSE);
		m_i2c.SendByte((val & 0xFF), FALSE);
		m_i2c.EndTransmission();
		m_i2c.Commit();

		val = 0x0A00;
		m_i2c.BeginTransmission(INA226_ADDR, FALSE);
		m_i2c.SendByte(INA226_REG_CALIBRATION, FALSE);
		m_i2c.SendByte((val >> 8) & 0xFF, FALSE);
		m_i2c.SendByte((val & 0xFF), FALSE);
		m_i2c.EndTransmission();
		m_i2c.Commit();


		SetTimer(TIMER_ID_UPDATE, 200, NULL);
	}
	catch(CFtException* e)
	{
		e->ReportError();
		e->Delete();
	}

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CBitBangI2CDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBitBangI2CDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBitBangI2CDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CBitBangI2CDlg::OnBnClickedOk()
{
//	OnOK();
}

void CBitBangI2CDlg::OnBnClickedCancel()
{
	OnCancel();
}

void CBitBangI2CDlg::OnDestroy()
{
	CDialog::OnDestroy();

	try
	{
		m_i2c.Close();
	}
	catch(CFtException* e)
	{
		e->ReportError();
		e->Delete();
	}
}

void CBitBangI2CDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == TIMER_ID_UPDATE)
	{
		try
		{
			int i;

			// WX^l擾
			for(i = 0; i < NELEMS(st_aRegs); i++)
			{
				const REG_INFO* pInfo = &st_aRegs[i];
				WORD	val;
				CString	str;
				
				val = GetRegister(pInfo->reg);

				m_regMap[pInfo->reg] = val;

				str.Format("%04X", val);
				m_lcReg.SetItemText(i, 2, str);
			}

			CString	str;
			double	busVal;
			double	currVal;
			double	powVal;

			busVal	= (double)m_regMap[INA226_REG_BUS_VOLTAGE] * 1.25;

			if(m_regMap[INA226_REG_CURRENT] >= 0x8000)
				currVal	= (double)(0x10000 - m_regMap[INA226_REG_CURRENT]);
			else
				currVal	= (double)m_regMap[INA226_REG_CURRENT];

			if(m_regMap[INA226_REG_POWER] >= 0x8000)
				powVal	= (double)(0x10000 - m_regMap[INA226_REG_POWER]) * -2.5;
			else
				powVal	= (double)m_regMap[INA226_REG_POWER] * 2.5;

			str.Format("%.2lf mV", busVal);
			m_stBus.SetWindowText(str);

			str.Format("%.2lf mA", currVal);
			m_stCurr.SetWindowText(str);

			str.Format("%.2lf mW", powVal);
			m_stPow.SetWindowText(str);
		}
		catch(CFtException* e)
		{
			e->Delete();
		}
	}
	else
	{
		CDialog::OnTimer(nIDEvent);
	}
}
