
// BitBangI2CDlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"
#include "FtI2C.h"
#include "afxcmn.h"


enum DS1721_CMD
{
	DS1721_CMD_ACCESS_CONFIGURATION	= 0xAC,
	DS1721_CMD_ACCESS_TH			= 0xA1,
	DS1721_CMD_ACCESS_TL			= 0xA2,
	DS1721_CMD_START_CONVERT_T		= 0x51,
	DS1721_CMD_STOP_CONVERT_T		= 0x22,
	DS1721_CMD_READ_TEMPERATURE		= 0xAA,
};

enum INA226_REG
{
	INA226_REG_CONGIGURATION_REG	= 0x00,	// Configuration Register
	INA226_REG_SHUNT_VOLTAGE		= 0x01,	// Shunt Voltage
	INA226_REG_BUS_VOLTAGE			= 0x02,	// Bus Voltage
	INA226_REG_POWER				= 0x03,	// Power
	INA226_REG_CURRENT				= 0x04,	// Current
	INA226_REG_CALIBRATION			= 0x05,	// Calibration
	INA226_REG_MASK_ENABLE			= 0x06,	// Mask/Enable
	INA226_REG_ALERT_LIMIT			= 0x07,	// Alert Limit
	INA226_REG_DIE_ID				= 0xFF,	// Die ID
};

const int DS1721_ADDR	= 0x4F;		// DS1721 I2C Address
const int INA226_ADDR	= 0x40;		// INA226 I2C Address (A0=A1=GND)




// CBitBangI2CDlg _CAO
class CBitBangI2CDlg : public CDialog
{
// RXgNV
public:
	CBitBangI2CDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_BITBANGI2C_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnDestroy();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	DECLARE_MESSAGE_MAP()

	WORD GetRegister(INA226_REG reg);

private:
	CString	m_strOldTemp;

	CFtI2C		m_i2c;
	CListCtrl	m_lcReg;

	CFont		m_font;
	CStatic		m_stBus;
	CStatic		m_stCurr;
	CStatic		m_stPow;

	CMap<INA226_REG, INA226_REG, WORD, WORD>	m_regMap;
};

