// FtCtrl.cpp: CFtCtrl NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FtCtrl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#pragma comment(lib, "FTD2XX.lib")
#pragma warning(disable : 4312)			// 64rbgڐAւ̑Ή[jO𖳌

#include "FtException.h"


/* ========================================================================
	RXgN^EfXgN^
 ======================================================================== */

CFtCtrl::CFtCtrl()
{
	m_hFt	= INVALID_HANDLE_VALUE;
}

CFtCtrl::~CFtCtrl()
{
	if(m_hFt != INVALID_HANDLE_VALUE)
	{
		if(IsOpen())
			Close();
	}
}


/* ========================================================================
	⏕֐
 ======================================================================== */

/* ------------------------------------------------------------------
		int CFtCtrl::WriteBytes(const BYTE* pbSrc, int nLen)
	@\	oCgM
		pbSrc	Mf[^
			nLen	MoCg
	߂l	MoCg
	l	
 ------------------------------------------------------------------ */
int CFtCtrl::WriteBytes(const BYTE* pbSrc, int nLen)
{
	DWORD	dwWritten	= 0;
	Write(pbSrc, nLen, &dwWritten);
	return	(int)dwWritten;
}

/* ------------------------------------------------------------------
		int CFtCtrl::ReadBytes(BYTE* pbDst, int nLen)
	@\	oCgM
		pbDst	Mf[^
			nLen	MoCg
	߂l	MoCg
	l	
 ------------------------------------------------------------------ */
int CFtCtrl::ReadBytes(BYTE* pbDst, int nLen)
{
	DWORD	dwRead	= 0;
	Read(pbDst, nLen, &dwRead);
	return	(int)dwRead;
}

/* ------------------------------------------------------------------
		void CFtCtrl::WriteByte(BYTE bData)
	@\	1oCgM
		bData	Mf[^
	߂l	
	l	
 ------------------------------------------------------------------ */
void CFtCtrl::WriteByte(BYTE bData)
{
	WriteBytes(&bData, sizeof(bData));
}

/* ------------------------------------------------------------------
		BYTE CFtCtrl::WriteByte(BYTE bData)
	@\	1oCgM
		
	߂l	Mf[^
	l	
 ------------------------------------------------------------------ */
BYTE CFtCtrl::ReadByte()
{
	BYTE	bData	= 0;
	ReadBytes(&bData, sizeof(bData));
	return	bData;
}

/* ------------------------------------------------------------------
		int CFtCtrl::GetQueBytes()
	@\	ML[ɓĂf[^̃oCg擾
		
	߂l	f[^̃oCg
	l	
 ------------------------------------------------------------------ */
int CFtCtrl::GetQueBytes()
{
	DWORD	dwLen	= 0;
	GetQueueStatus(&dwLen);
	return	(int)dwLen;
}

/* ------------------------------------------------------------------
		int CFtCtrl::EnumDevices(FT_DEV_INFO pInfoArray[], int nArraySize)
	@\	ڑĂfoCX擾
		pInfoArray	foCXi[z
			nArraySize	foCXi[z̗vf
	߂l	i[foCX̐
	l	static ֐
 ------------------------------------------------------------------ */
int CFtCtrl::EnumDevices(FT_DEV_INFO pInfoArray[], int nArraySize)
{
	int		i;
	DWORD	dwNumDevs;					// 擾foCX
	int		nNumDevsTotal	= 0;		// ʂƂĊi[foCX

	// 
	for(i = 0; i < nArraySize; i++)
	{
		LPFT_DEV_INFO	pInfo	= &pInfoArray[i];
		memset(pInfo, 0, sizeof(FT_DEV_INFO));
		pInfo->nIndex	= -1;
	}

	// foCX擾
	ListDevices(&dwNumDevs, NULL, FT_LIST_NUMBER_ONLY);

	// CfBbNXfBXNv^EVAԍ擾
	for(i = 0; i < min((int)dwNumDevs, nArraySize); i++)
	{
		LPFT_DEV_INFO	pInfo	= &pInfoArray[i];
		ListDevices((LPVOID)i, pInfo->szDesc, FT_LIST_BY_INDEX | FT_OPEN_BY_DESCRIPTION);
		ListDevices((LPVOID)i, pInfo->szSer, FT_LIST_BY_INDEX | FT_OPEN_BY_SERIAL_NUMBER);
		pInfo->nIndex	= i;
	}

	return	nNumDevsTotal;
}

/* ------------------------------------------------------------------
		BOOL CFtCtrl::IsOpen() const
	@\	foCX̃I[vԂ擾
		
	߂l	TRUE:I[v
	l	
 ------------------------------------------------------------------ */
BOOL CFtCtrl::IsOpen() const
{
	return	(m_hFt != INVALID_HANDLE_VALUE);
}

/* ------------------------------------------------------------------
		const char* CFtCtrl::GetFtStatusStr(FT_STATUS nStatus)
	@\	API ߂lɑΉ郁bZ[W擾
		nStatus		API ߂l
	߂l	bZ[Wւ̃|C^ ('\0'I[)
	l	static ֐
 ------------------------------------------------------------------ */
const char* CFtCtrl::GetFtStatusStr(FT_STATUS nStatus)
{
	switch(nStatus)
	{
    case FT_OK:
		return	"FT_OK";

	case FT_INVALID_HANDLE:
		return	"FT_INVALID_HANDLE";

	case FT_DEVICE_NOT_FOUND:
		return	"FT_DEVICE_NOT_FOUND";

	case FT_DEVICE_NOT_OPENED:
		return	"FT_DEVICE_NOT_OPENED";

	case FT_IO_ERROR:
		return	"FT_IO_ERROR";

	case FT_INSUFFICIENT_RESOURCES:
		return	"FT_INSUFFICIENT_RESOURCES";

	case FT_INVALID_PARAMETER:
		return	"FT_INVALID_PARAMETER";

	case FT_INVALID_BAUD_RATE:
		return	"FT_INVALID_BAUD_RATE";

	case FT_DEVICE_NOT_OPENED_FOR_ERASE:
		return	"FT_DEVICE_NOT_OPENED_FOR_ERASE";

	case FT_DEVICE_NOT_OPENED_FOR_WRITE:
		return	"FT_DEVICE_NOT_OPENED_FOR_WRITE";

	case FT_FAILED_TO_WRITE_DEVICE:
		return	"FT_FAILED_TO_WRITE_DEVICE";

	case FT_EEPROM_READ_FAILED:
		return	"FT_EEPROM_READ_FAILED";

	case FT_EEPROM_WRITE_FAILED:
		return	"FT_EEPROM_WRITE_FAILED";

	case FT_EEPROM_ERASE_FAILED:
		return	"FT_EEPROM_ERASE_FAILED";

	case FT_EEPROM_NOT_PRESENT:
		return	"FT_EEPROM_NOT_PRESENT";

	case FT_EEPROM_NOT_PROGRAMMED:
		return	"FT_EEPROM_NOT_PROGRAMMED";

	case FT_INVALID_ARGS:
		return	"FT_INVALID_ARGS";

	case FT_NOT_SUPPORTED:
		return	"FT_NOT_SUPPORTED";

	case FT_OTHER_ERROR:	
		return	"FT_OTHER_ERROR";
	}

	return	"undefined FT_STATUS value.";
}


/* ------------------------------------------------------------------
		FT_STATUS CFtCtrl::ValidStatus(FT_STATUS nStatus, const char* szFunc, BOOL fThrowException)
	@\	API ̖߂l]
		nStatus			API ̖߂l
			szFunc			֐
			fThrowException	TRUE:Oos
	߂l	nStatus Ɠl
	l	static ֐CŎgp
 ------------------------------------------------------------------ */
FT_STATUS CFtCtrl::ValidStatus(FT_STATUS nStatus, const char* szFunc, BOOL fThrowException)
{
#ifdef FTCTRL_THROW_EXCEPTION
	if(fThrowException != 0)
	{
		if((nStatus != FT_OK)/* && (nStatus != FT_DEVICE_NOT_FOUND)*/)
		{
			throw(new CFtException(nStatus, szFunc));
		}
	}
#endif // FTCTRL_THROW_EXCEPTION

	return	nStatus;
}


/* ========================================================================
	bp֐
 ======================================================================== */

FT_STATUS CFtCtrl::Open(
	int deviceNumber
	)
{
	return	ValidStatus(
		FT_Open(deviceNumber, &m_hFt), 
		"FT_Open"
		);
}

FT_STATUS CFtCtrl::OpenEx(
	const VOID* pArg1,
	DWORD Flags
	)
{
	return	ValidStatus(
		FT_OpenEx((LPVOID)pArg1, Flags, &m_hFt), 
		"FT_OpenEx"
		);
}

// static
FT_STATUS CFtCtrl::ListDevices(
	PVOID pArg1,
	PVOID pArg2,
	DWORD Flags
	)
{
	return	ValidStatus(
		FT_ListDevices(pArg1, pArg2, Flags), 
		"FT_ListDevices"
		);
}

FT_STATUS CFtCtrl::Close(
	)
{
	FT_STATUS	nStatus	= 
		ValidStatus(
		FT_Close(m_hFt), 
		"FT_Close",
		FALSE				// OsȂ
		);

	if(nStatus == FT_OK)
	{
		m_hFt	= INVALID_HANDLE_VALUE;
	}

	return	nStatus;
}

FT_STATUS CFtCtrl::Read(
	LPVOID lpBuffer,
	DWORD nBufferSize,
	LPDWORD lpBytesReturned
	)
{
	return	ValidStatus(
		FT_Read(m_hFt, lpBuffer, nBufferSize, lpBytesReturned), 
		"FT_Read"
		);
}

FT_STATUS CFtCtrl::Write(
//	LPVOID lpBuffer,
	const VOID* lpBuffer,
	DWORD nBufferSize,
	LPDWORD lpBytesWritten
	)
{
	return	ValidStatus(
		FT_Write(m_hFt, (LPVOID)lpBuffer, nBufferSize, lpBytesWritten), 
		"FT_Write"
		);
}

FT_STATUS CFtCtrl::IoCtl(
	DWORD dwIoControlCode,
	LPVOID lpInBuf,
	DWORD nInBufSize,
	LPVOID lpOutBuf,
	DWORD nOutBufSize,
	LPDWORD lpBytesReturned,
	LPOVERLAPPED lpOverlapped
	)
{
	return	ValidStatus(
		FT_IoCtl(m_hFt, dwIoControlCode, lpInBuf, nInBufSize, lpOutBuf, nOutBufSize, lpBytesReturned, lpOverlapped), 
		"FT_IoCtl"
		);
}

FT_STATUS CFtCtrl::SetBaudRate(
	ULONG BaudRate
	)
{
	return	ValidStatus(
		FT_SetBaudRate(m_hFt, BaudRate), 
		"FT_SetBaudRate"
		);
}

FT_STATUS CFtCtrl::SetDivisor(
	USHORT Divisor
	)
{
	return	ValidStatus(
		FT_SetDivisor(m_hFt, Divisor), 
		"FT_SetDivisor"
		);
}

FT_STATUS CFtCtrl::SetDataCharacteristics(
	UCHAR WordLength,
	UCHAR StopBits,
	UCHAR Parity
	)
{
	return	ValidStatus(
		FT_SetDataCharacteristics(m_hFt, WordLength, StopBits, Parity), 
		"FT_SetDataCharacteristics"
		);
}

FT_STATUS CFtCtrl::SetFlowControl(
	USHORT FlowControl,
	UCHAR XonChar,
	UCHAR XoffChar
	)
{
	return	ValidStatus(
		FT_SetFlowControl(m_hFt, FlowControl, XonChar, XoffChar), 
		"FT_SetFlowControl"
		);
}

FT_STATUS CFtCtrl::ResetDevice()
{
	return	ValidStatus(
		FT_ResetDevice(m_hFt), 
		"FT_ResetDevice"
		);
}

FT_STATUS CFtCtrl::SetDtr()
{
	return	ValidStatus(
		FT_SetDtr(m_hFt), 
		"FT_SetDtr"
		);
}

FT_STATUS CFtCtrl::ClrDtr()
{
	return	ValidStatus(
		FT_ClrDtr(m_hFt), 
		"FT_ClrDtr"
		);
}

FT_STATUS CFtCtrl::SetRts()
{
	return	ValidStatus(
		FT_SetRts(m_hFt), 
		"FT_SetRts"
		);
}

FT_STATUS CFtCtrl::ClrRts()
{
	return	ValidStatus(
		FT_SetRts(m_hFt), 
		"FT_SetRts"
		);
}

FT_STATUS CFtCtrl::GetModemStatus(
	ULONG *pModemStatus
	)
{
	return	ValidStatus(
		FT_GetModemStatus(m_hFt, pModemStatus), 
		"FT_GetModemStatus"
		);
}

FT_STATUS CFtCtrl::SetChars(
	UCHAR EventChar,
	UCHAR EventCharEnabled,
	UCHAR ErrorChar,
	UCHAR ErrorCharEnabled
	)
{
	return	ValidStatus(
		FT_SetChars(m_hFt, EventChar, EventCharEnabled, ErrorChar, ErrorCharEnabled), 
		"FT_SetChars"
		);
}

FT_STATUS CFtCtrl::Purge(
	ULONG Mask
	)
{
	return	ValidStatus(
		FT_Purge(m_hFt, Mask), 
		"FT_Purge"
		);
}

FT_STATUS CFtCtrl::SetTimeouts(
	ULONG ReadTimeout,
	ULONG WriteTimeout
	)
{
	return	ValidStatus(
		FT_SetTimeouts(m_hFt, ReadTimeout, WriteTimeout), 
		"FT_SetTimeouts"
		);
}

FT_STATUS CFtCtrl::GetQueueStatus(
	DWORD *dwRxBytes
	)
{
	return	ValidStatus(
		FT_GetQueueStatus(m_hFt, dwRxBytes), 
		"FT_GetQueueStatus"
		);
}

FT_STATUS CFtCtrl::SetEventNotification(
	DWORD Mask,
	PVOID Param
	)
{
	return	ValidStatus(
		FT_SetEventNotification(m_hFt, Mask, Param), 
		"FT_SetEventNotification"
		);
}

FT_STATUS CFtCtrl::GetStatus(
	DWORD *dwRxBytes,
	DWORD *dwTxBytes,
	DWORD *dwEventDWord
	)
{
	return	ValidStatus(
		FT_GetStatus(m_hFt, dwRxBytes, dwTxBytes, dwEventDWord), 
		"FT_GetStatus"
		);
}

FT_STATUS CFtCtrl::SetBreakOn()
{
	return	ValidStatus(
		FT_SetBreakOn(m_hFt), 
		"FT_SetBreakOn"
		);
}

FT_STATUS CFtCtrl::SetBreakOff()
{
	return	ValidStatus(
		FT_SetBreakOff(m_hFt), 
		"FT_SetBreakOff"
		);
}

FT_STATUS CFtCtrl::SetWaitMask(
	DWORD Mask
	)
{
	return	ValidStatus(
		FT_SetWaitMask(m_hFt, Mask), 
		"FT_SetWaitMask"
		);
}

FT_STATUS CFtCtrl::WaitOnMask(
	DWORD *Mask
	)
{
	return	ValidStatus(
		FT_WaitOnMask(m_hFt, Mask), 
		"FT_WaitOnMask"
		);
}

FT_STATUS CFtCtrl::GetEventStatus(
	DWORD *dwEventDWord
	)
{
	return	ValidStatus(
		FT_GetEventStatus(m_hFt, dwEventDWord), 
		"FT_GetEventStatus"
		);
}

FT_STATUS CFtCtrl::ReadEE(
	DWORD dwWordOffset,
	LPWORD lpwValue
	)
{
	return	ValidStatus(
		FT_ReadEE(m_hFt, dwWordOffset, lpwValue), 
		"FT_ReadEE"
		);
}

FT_STATUS CFtCtrl::WriteEE(
	DWORD dwWordOffset,
	WORD wValue
	)
{
	return	ValidStatus(
		FT_WriteEE(m_hFt, dwWordOffset, wValue), 
		"FT_WriteEE"
		);
}

FT_STATUS CFtCtrl::EraseEE()
{
	return	ValidStatus(
		FT_EraseEE(m_hFt), 
		"FT_EraseEE"
		);
}

// FT8U232/245BM
FT_STATUS CFtCtrl::EE_Program(
	PFT_PROGRAM_DATA pData
	)
{
	return	ValidStatus(
		FT_EE_Program(m_hFt, pData), 
		"FT_EE_Program"
		);
}

FT_STATUS CFtCtrl::EE_Read(
	PFT_PROGRAM_DATA pData
	)
{
	return	ValidStatus(
		FT_EE_Read(m_hFt, pData), 
		"FT_EE_Read"
		);
}

FT_STATUS CFtCtrl::EE_UASize(
	LPDWORD lpdwSize
	)
{
	return	ValidStatus(
		FT_EE_UASize(m_hFt, lpdwSize), 
		"FT_EE_UASize"
		);
}

FT_STATUS CFtCtrl::EE_UAWrite(
	PUCHAR pucData,
	DWORD dwDataLen
	)
{
	return	ValidStatus(
		FT_EE_UAWrite(m_hFt, pucData, dwDataLen), 
		"FT_EE_UAWrite"
		);
}

FT_STATUS CFtCtrl::EE_UARead(
	PUCHAR pucData,
	DWORD dwDataLen,
	LPDWORD lpdwBytesRead
	)
{
	return	ValidStatus(
		FT_EE_UARead(m_hFt, pucData, dwDataLen, lpdwBytesRead), 
		"FT_EE_UARead"
		);
}

FT_STATUS CFtCtrl::SetLatencyTimer(
	UCHAR ucLatency
	)
{
	return	ValidStatus(
		FT_SetLatencyTimer(m_hFt, ucLatency), 
		"FT_SetLatencyTimer"
		);
}

FT_STATUS CFtCtrl::GetLatencyTimer(
	PUCHAR pucLatency
	)
{
	return	ValidStatus(
		FT_GetLatencyTimer(m_hFt, pucLatency), 
		"FT_GetLatencyTimer"
		);
}

FT_STATUS CFtCtrl::SetBitMode(
	UCHAR ucMask,
	UCHAR ucEnable
	)
{
	return	ValidStatus(
		FT_SetBitMode(m_hFt, ucMask, ucEnable), 
		"FT_SetBitMode"
		);
}

FT_STATUS CFtCtrl::GetBitMode(
	PUCHAR pucMode
	)
{
	return	ValidStatus(
		FT_GetBitMode(m_hFt, pucMode), 
		"FT_GetBitMode"
		);
}

FT_STATUS CFtCtrl::SetUSBParameters(
	ULONG ulInTransferSize,
	ULONG ulOutTransferSize
	)
{
	return	ValidStatus(
		FT_SetUSBParameters(m_hFt, ulInTransferSize, ulOutTransferSize), 
		"FT_SetUSBParameters"
		);
}

FT_STATUS CFtCtrl::GetDeviceInfo(
	FT_DEVICE *lpftDevice,
	LPDWORD lpdwID,
	PCHAR SerialNumber,
	PCHAR Description,
	LPVOID Dummy
	)
{
	return	ValidStatus(
		FT_GetDeviceInfo(m_hFt, lpftDevice, lpdwID, SerialNumber, Description, Dummy), 
		"FT_GetDeviceInfo"
		);
}


